/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package java_etu;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
//import org.graphstream.algorithm.coloring.WelshPowell;
import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;
import org.graphstream.ui.swingViewer.View;
import org.graphstream.ui.swingViewer.Viewer;


public class FenetrePrincipale extends JFrame {

    Graph grapheCourant;
    PanneauVisu panoVisu;
    PanneauGraphe panoGraphe;
    PanneauActions panoActions;
    PanneauAlgorithmes panoAlgo;
    int nbcouleurs=10;

    public FenetrePrincipale() {
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panoVisu = new PanneauVisu();
        panoGraphe = new PanneauGraphe();
        panoActions = new PanneauActions();
        panoAlgo = new PanneauAlgorithmes();

        this.getContentPane().setLayout(new GridBagLayout());
        GridBagConstraints cont = new GridBagConstraints();
        cont.fill = GridBagConstraints.BOTH;
        cont.weighty = 1.0;
        cont.gridx = 0;
        cont.gridy = 0;
        cont.gridheight = 3;
        this.getContentPane().add(panoVisu, cont);
        cont.gridx = 1;
        cont.gridheight = 1;
        this.getContentPane().add(panoGraphe, cont);
        cont.gridy = 1;
        this.getContentPane().add(panoActions, cont);
        cont.gridy = 2;
        this.getContentPane().add(panoAlgo, cont);

        this.pack();

    }

    public class PanneauVisu extends JPanel {

        final String styleSheet = "node {"
                + "size-mode: dyn-size;"
                + " fill-color: red;"
                + " size: 10px;"
                + " stroke-mode: plain;"
                + " stroke-color: black;"
                + " stroke-width: 1px;"
                + "}"
                + "node.important {"
                + " fill-color: red;"
                + " size: 30px;"
                + "}"
                + "edge {"
                + "text-alignment: along;"
                + "}"
                + "edge.notintree {"
                + "size:1px;"
                + "fill-color:gray;"
                + "} "
                + "edge.intree {size:3px;fill-color:blue;}";

        public Viewer graphViewer = null;
        public View graphView = null;

        public PanneauVisu() {
            this.setLayout(new BorderLayout());
            this.setPreferredSize(new Dimension(800, 600));
        }

        public void update() {
            if (grapheCourant != null) {
                try {
                    this.remove(graphViewer.getView(Viewer.DEFAULT_VIEW_ID));
                } catch (Exception ex) {
                }
                grapheCourant.addAttribute("ui.stylesheet", styleSheet);
                graphViewer = new Viewer(grapheCourant, Viewer.ThreadingModel.GRAPH_IN_ANOTHER_THREAD);
                graphViewer.enableAutoLayout();
                graphView = graphViewer.addDefaultView(false);
                this.add(graphView);
                graphView.revalidate();
            }
        }
    }

    public class PanneauGraphe extends JPanel {

        public JComboBox<TypeGraphe> comboChoixGraphe = new JComboBox(new DefaultComboBoxModel());
        public JButton btGraphe = new JButton("Générer");
        public int args[];

        public PanneauGraphe() {
            this.setBorder(BorderFactory.createTitledBorder("Choix du graphe"));
            //remplissage du combo
            for (TypeGraphe x : TypeGraphe.values()) {
                ((DefaultComboBoxModel) comboChoixGraphe.getModel()).addElement(x);
            }
            //ajout des éléments graphiques
            this.setLayout(new GridBagLayout());
            GridBagConstraints cont = new GridBagConstraints();
            cont.gridx = cont.gridy = 0;
            this.add(comboChoixGraphe, cont);
            cont.gridx = 1;
            this.add(btGraphe, cont);
            //action bouton
            btGraphe.addActionListener(new ActionListener() {

                @Override
                public void actionPerformed(ActionEvent e) {
                    TypeGraphe type = (TypeGraphe) ((DefaultComboBoxModel) comboChoixGraphe.getModel()).getSelectedItem();
                    if (new BoiteParam(PanneauGraphe.this, type.toString(), type.getParam()).isActivee()) {
                        grapheCourant = GrapheFabrique.generer(type, args);
                        panoVisu.update();
                    }
                }
            });
        }

        //pour mettre à jour les données saisies dans la boite de dialogue
        public void maj(int args[]) {
            this.args = new int[args.length];
            for (int i = 0; i < args.length; i++) {
                this.args[i] = args[i];
            }
        }

    }

    public class PanneauActions extends JPanel {
        public JLabel nbcouleurs_label= new JLabel("#couleurs");
        public JTextField nbcouleurs_field = new JTextField("10");
        
        public PanneauActions(){
            this.setBorder(BorderFactory.createTitledBorder("Choix des parametres"));
            //remplissage du combo        
            //ajout des éléments graphiques
            this.setLayout(new GridBagLayout());
            GridBagConstraints cont = new GridBagConstraints();
            cont.gridx = cont.gridy = 0;
            this.add(nbcouleurs_label, cont);
            cont.gridy=1;
            nbcouleurs_field.setColumns(8);
            this.add(nbcouleurs_field, cont);
        }              
        
        public void getNbCouleurs(){
            nbcouleurs = Integer.parseInt(nbcouleurs_field.getText());
        }
                
    }

    public class PanneauAlgorithmes extends JPanel {
        
        public JButton welsh_button = new JButton("Welsh Powell");
        public JLabel welsh_label= new JLabel("     ");
        
        public JButton alea_button = new JButton("Aleatoire");
        public JLabel alea_label = new JLabel("       ");
        
        public JButton descent_button = new JButton("Descente");
        public JLabel descent_label= new JLabel("     ");
        
        public JButton tabu_button = new JButton("Tabu");
        public JLabel tabu_label= new JLabel("     ");

        
        public PanneauAlgorithmes(){
            this.setBorder(BorderFactory.createTitledBorder("Choix de l'algo"));
            //remplissage du combo        
            //ajout des éléments graphiques
            this.setLayout(new GridBagLayout());
            GridBagConstraints cont = new GridBagConstraints();
            cont.gridx = cont.gridy = 0;
            this.add(alea_button, cont);
            cont.gridy=1;
            this.add(alea_label, cont);
            cont.gridx = 1; cont.gridy = 0;
            this.add(descent_button, cont);
            cont.gridy=1;
            this.add(descent_label, cont);
            cont.gridx = 2; cont.gridy = 0;
            this.add(tabu_button, cont);
            cont.gridy=1;
            this.add(tabu_label, cont);

            alea_button.addActionListener(new ActionListener() {             
                @Override
                public void actionPerformed(ActionEvent ae) {
                    panoActions.getNbCouleurs();
                    alea();
                }   
                private void alea() {
                    int nbsommets=grapheCourant.getNodeCount();             
                    for (int i=0;i<nbsommets;i++){
                        if (grapheCourant.getNode(i).hasAttribute("color_alea"))
                            grapheCourant.getNode(i).setAttribute("color_alea",(int)(Math.random()*nbcouleurs));
                        else
                            grapheCourant.getNode(i).addAttribute("color_alea",(int)(Math.random()*nbcouleurs));
                    }
                    Color[] cols = new Color[nbcouleurs];
                    
                    for (int i = 0; i < nbcouleurs; i++) {
                        cols[i] = Color.getHSBColor((float) (Math.random()), 0.8f, 0.9f);
                    }
                    for (Node n : grapheCourant) {
                        int col = n.getAttribute("color_alea");
                        n.addAttribute("ui.style", "fill-color:rgba(" + cols[col].getRed() + "," + cols[col].getGreen() + "," + cols[col].getBlue() + ",200);");
                    }
                    alea_label.setText(""+getNbConflits("color_alea"));
                }
            });
            
            descent_button.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent ae) {
                    panoActions.getNbCouleurs();
                    descent();
                }

                private void descent() {   
                    //la couleur des noeuds sera stockée dans l'attribut color_descent
                    //la boucle ci-dessous initialise les couleurs aléatoirement
                    int nbsommets=grapheCourant.getNodeCount();
                    for (int i=0;i<nbsommets;i++){
                        if (grapheCourant.getNode(i).hasAttribute("color_descent"))
                            grapheCourant.getNode(i).addAttribute("color_descent",(int)(Math.random()*nbcouleurs));
                        else
                            grapheCourant.getNode(i).setAttribute("color_descent",(int)(Math.random()*nbcouleurs));
                    }
                    //mapping des attributs couleurs vers couleurs, utilisé uniquement pour affichage
                    Color[] cols = new Color[nbcouleurs];
                    for (int i = 0; i < nbcouleurs; i++) {
                        cols[i] = Color.getHSBColor((float) (Math.random()), 0.8f, 0.9f);
                    }
                    
                    //descente à coder, vous devez affecter les attributs color_descent
                    
                    //on colorie les noeuds à la fin de l'algo
                    for (Node n : grapheCourant) {
                        int col = (int) n.getNumber("color_descent");
                        n.addAttribute("ui.style", "fill-color:rgba(" + cols[col].getRed() + "," + cols[col].getGreen() + "," + cols[col].getBlue() + ",200);");
                    }
                    //on affiche le nombre de conflits à la fin de la descente
                    descent_label.setText(""+getNbConflits("color_descent"));
                    
                }
                               
            
            });
            
            
            tabu_button.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent ae) {
                    panoActions.getNbCouleurs();
                    tabu(300);
                }

                private void tabu(int nb_iterations_max) {
                    int nbsommets=grapheCourant.getNodeCount();
                    for (int i=0;i<nbsommets;i++){
                        if (grapheCourant.getNode(i).hasAttribute("color_tabu"))
                            grapheCourant.getNode(i).setAttribute("color_tabu",(int)(Math.random()*nbcouleurs));
                        else 
                            grapheCourant.getNode(i).addAttribute("color_tabu",(int)(Math.random()*nbcouleurs));
                    }
                    
                     //mapping atributs couleurs vers couleurs
                    Color[] cols = new Color[nbcouleurs];
                    for (int i = 0; i < nbcouleurs; i++) {
                        cols[i] = Color.getHSBColor((float) (Math.random()), 0.8f, 0.9f);
                    }
                    
                    //recherche tabou a coder
                    
                     //on colorie les noeuds
                    for (Node n : grapheCourant) {
                        int col = n.getAttribute("color_tabu");
                        if (n.hasAttribute("ui.style"))
                            n.setAttribute("ui.style", "fill-color:rgba(" + cols[col].getRed() + "," + cols[col].getGreen() + "," + cols[col].getBlue() + ",200);");
                        else 
                            n.addAttribute("ui.style", "fill-color:rgba(" + cols[col].getRed() + "," + cols[col].getGreen() + "," + cols[col].getBlue() + ",200);");
                    }
                    tabu_label.setText("-1");
                }
            
            
            });
        }
    }
    
    //calcule le nombre de conflits pour un seul sommet n, en utilisant la couleur attrName
    public int getNbConflits(Node n,String attrName){
        
        
        // a coder
        
        return -1;
    }
        
    //calcule le nombre de conflits pour tout le graphe, en utilisant la couleur attrName
    public int getNbConflits(String attrName){
        //a coder
        
        return -1;
    }    
    
        
    
}
